//+------------------------------------------------------------------+
//|                                     TickVoltyChannel_Stop_v1.mq4 |
//|                          Many Thanks to Rosh for Ticks indicator |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-09, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Lime
#property indicator_color2 Aqua
#property indicator_color3 Magenta
#property indicator_color4 Aqua
#property indicator_color5 Magenta

//---- input parameters
extern int    PriceMode    =     0; //0-Bid,1-Hi/Lo Bid around 3 ticks
extern int    Length       =    10; //Volatility's Period
extern double Kv           =     3; //Volatility's Factor or Multiplier
extern int    SignalMode   =     1; //0-Signal off,1-on
extern int    AlertMode    =     0; //0-alert off,1-on
extern int    VisualMode   =     0; //0-lines,1-dots 
extern int    UseDelimiter =     1; //Delimiter Mode: 0-off,1-on
extern color  DelimColor   =  Gray; //Color of Bars Delimiter 
extern int    MaxTicks     =   200; //Max Number of ticks   


int    EmailMode    =     0; //0-Email off,1-on 


//---- indicator buffers
double Ticks[];
double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[];
double smin[];
double smax[];
double trend[];


bool UpTrendAlert=false, DnTrendAlert=false;
int      tickCounter=0;
int      delimeterCounter;
datetime pTime;
string   short_name, setup;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   IndicatorBuffers(8);
   SetIndexBuffer(0,Ticks);
   SetIndexBuffer(1,UpBuffer);
   SetIndexBuffer(2,DnBuffer);
   SetIndexBuffer(3,UpSignal);
   SetIndexBuffer(4,DnSignal);
   SetIndexBuffer(5,smin);
   SetIndexBuffer(6,smax);
   SetIndexBuffer(7,trend);
   
   SetIndexStyle(0,DRAW_LINE);
      if(VisualMode==0)
      {
      SetIndexStyle(1,DRAW_LINE);
      SetIndexStyle(2,DRAW_LINE);
      }
      else
      {
      SetIndexStyle(1,DRAW_ARROW);
      SetIndexStyle(2,DRAW_ARROW);
      SetIndexArrow(1,159);
      SetIndexArrow(2,159);
      }
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(3,108);
   SetIndexArrow(4,108);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   short_name="TickVoltyChannel_Stop_v1("+Length+","+DoubleToStr(Kv,3)+","+SignalMode+","+AlertMode+","+VisualMode+","+UseDelimiter+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Bid");
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"DnTrend");
   SetIndexLabel(3,"UpSignal");
   SetIndexLabel(4,"DnSignal");

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
//----
   setup = short_name+": ";
   pTime = Time[0];
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
   ObjDel(setup);
//----
   return(0);
}

void SetDelimeter()
{
//----
   string delimeterName = setup + TimeToStr(Time[0]);
   
   int handle=WindowFind(short_name);
   if(!ObjectCreate(delimeterName,OBJ_VLINE,handle,Time[0],0))
   {
   Print("Error delimiter:",GetLastError()," time=",TimeToStr(TimeCurrent(),TIME_SECONDS));
   }
   else 
   {
   ObjectSet(delimeterName,OBJPROP_COLOR,DelimColor);
   ObjectSet(delimeterName,OBJPROP_STYLE,STYLE_DOT);
   }
}

void ShiftArray()
{
   
   for(int cnt=tickCounter-1; cnt > 0; cnt--)
   {
   Ticks[cnt] = Ticks[cnt-1];
   UpBuffer[cnt] = UpBuffer[cnt-1];
   DnBuffer[cnt] = DnBuffer[cnt-1];
   UpSignal[cnt] = UpSignal[cnt-1];
   DnSignal[cnt] = DnSignal[cnt-1];
   smin[cnt] = smin[cnt-1];
   smax[cnt] = smax[cnt-1];
   trend[cnt] = trend[cnt-1];
   }
   
   if (UseDelimiter!=0)
   {
      for (int j=0;j<ObjectsTotal();j++)
      {
      int NumStr = StringFind(ObjectName(j),setup,0);
      
         if (NumStr == 0)
         {
         datetime Time1=ObjectGet(ObjectName(j),OBJPROP_TIME1);
         int BarTime1=iBarShift(NULL,0,Time1);
         Time1 = Time[BarTime1+1];
         ObjectSet(ObjectName(j),OBJPROP_TIME1,Time1); 
            if( BarTime1+1 > MaxTicks )
            {
               if (!ObjectDelete(ObjectName(j)))
               {
               int _GetLastError = GetLastError();
               Print("ObjectDelete: ",ObjectName(j)," Error #", _GetLastError );
               }
            }
         }       
      }
   }      
}

bool isNewBar()
{
   bool res=false;
   if (Time[0]!=pTime)
   {
   res=true;
   pTime=Time[0];
   }   

   return(res);
}

bool ObjDel(string name)
{
   int _GetLastError = 0;
     
   while(ObjFind(name,0,0) > 0)
   {
      int obtotal = ObjectsTotal();
      for (int i = 0; i < obtotal;i++)
      {
         if (StringFind(ObjectName(i),name,0) >= 0)
         {
            if (!ObjectDelete(ObjectName(i)))
            {
            _GetLastError = GetLastError();
            Print( "ObjectDelete( \"",ObjectName(i),"\" ) - Error #", _GetLastError );
            }
         }
      }
   }      
   if(_GetLastError > 0) return(false);
   else
   return (true);
}
//-----
int ObjFind(string name,int start, int num)
{
   int cnt = 0;
   
   for (int i = 0; i < ObjectsTotal();i++)
      if (StringFind(ObjectName(i),name,start) == num) cnt+=1;
   
   return(cnt);
}         
    
//+------------------------------------------------------------------+
//| TickVoltyChannel_Stop_v1                                         |
//+------------------------------------------------------------------+
int start()
{
   int i,cnt_bars = IndicatorCounted();
      
   if(cnt_bars < 1)
   {
      for(i=Bars-1;i > 0;i--)
      {
      Ticks[i]=0.0;
      UpBuffer[i]=0.0;
      DnBuffer[i]=0.0;
      UpSignal[i]=0.0;
      DnSignal[i]=0.0;
      }
   }
   
   tickCounter++;
      
   if(tickCounter >= MaxTicks) 
   {
   tickCounter = MaxTicks; 
   Ticks[tickCounter]=0.0;
   UpBuffer[tickCounter]=0.0;
   DnBuffer[tickCounter]=0.0;
   UpSignal[tickCounter]=0.0;
   DnSignal[tickCounter]=0.0;
   }
     
   if (isNewBar()){if(UseDelimiter == 1) SetDelimeter();}
   else
   ShiftArray();
      
   Ticks[0]=Bid;
   
   if(tickCounter > Length+3)
   {
      if(PriceMode == 0) {double Hi = Ticks[0]; double Lo = Ticks[0];} 
      else
      if(PriceMode == 1) {Hi = TickHighest(Ticks, 3); Lo = TickLowest (Ticks, 3);}
   
   double Volty = Average(Ticks,Length);
   
   smax[0] = Lo + Kv * Volty; 
   smin[0] = Hi - Kv * Volty; 
     
   trend[0]=trend[1];
   if (Ticks[0] > smax[1]) trend[0]= 1; 
	if (Ticks[0] < smin[1]) trend[0]=-1;
		  		
      if(trend[0] > 0)
      {
      if(smin[0] < smin[1]) smin[0] = smin[1];
      UpBuffer[0] = smin[0];
	      if (SignalMode > 0 && trend[1] != trend[0]) UpSignal[0] = smin[0];
	      else UpSignal[0] = 0.0;
	      if (SignalMode == 2) UpBuffer[0] = 0.0;
	   DnBuffer[0] = 0.0;
	   DnSignal[0] = 0.0;
	   }
	   else
	   if(trend[0] < 0)
	   {
      if(smax[0] > smax[1]) smax[0] = smax[1];
      DnBuffer[0] = smax[0];
         if(SignalMode > 0 && trend[1] != trend[0]) DnSignal[0] = smax[0];
         else DnSignal[0] = 0.0;
	      if(SignalMode == 2) DnBuffer[0] = 0.0;
	   UpBuffer[0] = 0.0;
	   UpSignal[0] = 0.0;
	   }
   }

   if(trend[2]<0 && trend[1]>0 && Volume[0]>1 && !UpTrendAlert)
	{
	string Message = " "+Symbol()+" TickVoltyChannel_Stop : Signal for BUY";
      if(AlertMode > 0) Alert (Message); 
      if(EmailMode > 0) SendMail ("Signal from TickVoltyChannel_Stop",TimeToStr(CurTime())+Message);
	UpTrendAlert=true; DnTrendAlert=false;
	} 
	else 	  
	if(trend[2]>0 && trend[1]<0 && Volume[0]>1 && !DnTrendAlert)
	{
	Message = " "+Symbol()+" TickVoltyChannel_Stop : Signal for SELL";
      if ( AlertMode > 0) Alert (Message); 
	   if ( EmailMode > 0) SendMail ("Signal from TickVoltyChannel_Stop",TimeToStr(CurTime())+Message);
	DnTrendAlert=true; UpTrendAlert=false;
	} 
  
   return(0);
}
//+------------------------------------------------------------------+
double TickLowest(double array[],int per)
{
   double lowest = 1000000;
   for(int i = 0;i < per;i++) lowest = MathMin(lowest,array[i]);
   return(lowest);
}                

double TickHighest(double array[],int per)
{
   double highest = 0;
   for(int i = 0;i < per;i++) highest = MathMax(highest,array[i]);
   return(highest);
}

double Average(double array[],int per)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) Sum += MathAbs(array[i]-array[i+1]);
   return(Sum/per);
}                                